package cz.frantovo.nekurak.servlet;

import cz.frantovo.nekurak.dto.Podnik;
import cz.frantovo.nekurak.ejb.PodnikRemote;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author fiki
 */
public class PodnikServlet extends SuperServlet {

	@EJB
	PodnikRemote ejb;

	@Override
	protected void doGet(HttpServletRequest požadavek, HttpServletResponse odpověď) throws ServletException, IOException {
		super.doGet(požadavek, odpověď);

		String[] parametryCesty = (požadavek.getPathInfo().split("/"));
		int id = Integer.parseInt(parametryCesty[1]);

		Podnik p = ejb.getPodnik(id);

		if (p == null) {
			odpověď.sendError(HttpServletResponse.SC_NOT_FOUND);
		} else {
			požadavek.setAttribute("podnik", p);
			požadavek.setAttribute("mapa", getMapa(p));
			zpracujJSP("detail.jsp", požadavek, odpověď);
		}
	}

	/**
	 * @return URL mapy – obrázku nebo null při chybě nebo absenci souřadnic
	 */
	private String getMapa(Podnik p) {
		if (p == null || p.getSirka() == null || p.getDelka() == null) {
			return null;
		} else {
			try {
				String souradnice = URLEncoder.encode(p.getSirka() + ", " + p.getDelka(), "UTF-8");
				return "https://maps.google.com/maps/api/staticmap?size=640x400&sensor=false&markers=size:big|color:green|" + souradnice;
			} catch (UnsupportedEncodingException e) {
				return null;
			}
		}
	}
}
