package cz.frantovo.nekurak.servlet;

import java.io.IOException;
import java.util.Locale;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author fiki
 */
public class SuperServlet extends HttpServlet {

	public static final String PARAMETR_JAZYK = "jazyk";
	private static final String ATRIBUT_JAZYK = "javax.servlet.jsp.jstl.fmt.locale.session";
	private static final String ADRESAR_SABLON = "/WEB-INF/casti/";
	

	@Override
	protected void doGet(HttpServletRequest požadavek, HttpServletResponse odpověď) throws ServletException, IOException {
		společné(požadavek, odpověď);
	}

	/**
	 * Vykreslí stránku pomocí JSP šablony
	 * @param jsp JSP šablona stránky – např. detail.jsp (nacházejí se v /WEB-INF/casti/)
	 */
	protected void zpracujJSP(String jsp, HttpServletRequest požadavek, HttpServletResponse odpověď) throws ServletException, IOException {
		/** Nastavení správného MIME typu */
		//požadavek.setAttribute("jspMimeTyp", MIME_TYP);




		/**
		 * odpověď.setContentType(MIME_TYP); – nefunguje (JSP si tam procpe svoje text/xml)
		 */
		/*
		 * Mělo by jít změnit přes web.xml:
		<jsp-config>
		<jsp-property-group>
		<url-pattern>/</url-pattern>
		<default-content-type>application/xhtml+xml</default-content-type>
		</jsp-property-group>
		</jsp-config>
		 */
		RequestDispatcher rd = getServletContext().getRequestDispatcher(ADRESAR_SABLON + jsp);
		rd.forward(požadavek, new XhtmlOdpověď(odpověď));
	}

	/**
	 * Společné činnosti, které děláme pro všechny HTTP metody (GET, POST atd.)
	 */
	private void společné(HttpServletRequest požadavek, HttpServletResponse odpověď) throws ServletException, IOException {
		nastavJazyk(požadavek);
	}

	/**
	 * Pokud se chce uživatel ručně přepnout na jiný jazyk, než jaký posílá jeho prohlížeč.
	 */
	private void nastavJazyk(HttpServletRequest požadavek) {
		String jazyk = požadavek.getParameter(PARAMETR_JAZYK);
		if (jazyk != null) {
			požadavek.getSession().setAttribute(ATRIBUT_JAZYK, new Locale(jazyk));
		}
	}
}
